<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="辨识部位" prop="riskPart">
        <el-input
          v-model="queryParams.riskPart"
          placeholder="请输入辨识部位"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="风险等级" prop="riskLevel">
        <el-select v-model="queryParams.riskLevel" clearable placeholder="请选择风险等级">
          <el-option
            v-for="dict in riskLevelOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="事故类型" prop="riskType">
        <el-select v-model="queryParams.riskType" placeholder="请选择事故类型" clearable size="small">
            <el-option
              v-for="dict in riskTypeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
        </el-select>
      </el-form-item>

      <el-form-item label="责任部门" prop="riskDept">
        <el-select
          v-model="queryParams.riskDept" placeholder="请选择责任部门" clearable size="small" >
          <el-option
            v-for="dict in deptList"
            :key="dict.deptId"
            :label="dict.deptName"
            :value="dict.deptId"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="责任人" prop="riskPerson">
        <el-input
          v-model="queryParams.riskPerson"
          placeholder="请输入责任人"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:manager:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:manager:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:manager:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		  :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['system:manager:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="managerList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="序号"  width="55" align="center" prop="id" />
      <el-table-column label="辨识部位" width="135"  align="center" prop="riskPart" />
      <el-table-column label="存在风险" align="center" prop="riskContent" />
      <el-table-column label="风险等级" width="75" align="center" prop="riskLevel" :formatter="riskLevelFormat"/>
      <el-table-column label="事故类型" width="95" align="center" prop="riskType" :formatter="riskTypeFormat"/>
      <el-table-column label="管控措施" align="center" prop="riskControl" />
      <el-table-column label="责任部门" width="85"  align="center" prop="riskDept" :formatter="riskDeptFormat"/>
      <el-table-column label="责任人" width="75" align="center" prop="riskPerson" />
      <el-table-column label="操作" width="115"  align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:manager:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:manager:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改【风险信息】对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="辨识部位" prop="riskPart">
          <el-input v-model="form.riskPart" placeholder="请输入辨识部位" />
        </el-form-item>
        <el-form-item label="存在风险">
          <editor v-model="form.riskContent" :min-height="192"/>
        </el-form-item>
        <el-form-item label="风险等级" prop="riskLevel">
          <el-select v-model="form.riskLevel" placeholder="请输入风险等级">
            <el-option
              v-for="dict in riskLevelOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="事故类型" prop="riskType">
          <el-select v-model="form.riskType" placeholder="请选择事故类型">
            <el-option
              v-for="dict in riskTypeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="管控措施" prop="riskControl">
          <el-input v-model="form.riskControl" placeholder="请输入管控措施" />
        </el-form-item>
        <el-form-item label="责任部门" prop="riskDept">
          <el-select v-model="form.riskDept" placeholder="请输入责任部门" >
            <el-option
              v-for="dict in deptList"
              :key="dict.deptId"
              :label="dict.deptName"
              :value="dict.deptId"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="责任人" prop="riskPerson">
          <el-input v-model="form.riskPerson" placeholder="请输入责任人" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listManager, getManager, delManager, addManager, updateManager, exportManager } from "@/api/system/manager";
import Editor from '@/components/Editor';
import { listDept} from "@/api/system/dept";
export default {
  name: "Manager",
  components: {
    Editor,
  },
  data() {
    return {
      riskTypeOptions:[],
      riskLevelOptions:[],
      deptList:[],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 【风险信息】表格数据
      managerList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        riskPart: null,
        riskContent: null,
        riskLevel: null,
        riskType: null,
        riskControl: null,
        riskDept: null,
        riskPerson: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.getDeptList();
    this.getriskTypeOptions();
    this.getriskLevelOptions();
  },
  methods: {
    getriskLevelOptions(){
      this.getDicts("risk_level").then(response => {
        this.riskLevelOptions = response.data;
      });
    },
    riskTypeFormat(row,colum){
      return this.selectDictLabel(this.riskTypeOptions, row.riskType);
    },
    riskLevelFormat(row,colum){
      return this.selectDictLabel(this.riskLevelOptions, row.riskLevel);
    },
    // 部门字典翻译
    riskDeptFormat(row, column) {
      var rst="";
      this.deptList.forEach(function(code) {
          if(code.deptId==row.riskDept){
            rst= code.deptName
          }
        })
      return rst
    },
    getriskTypeOptions(){
      this.getDicts("malfunction_type").then(response => {
        this.riskTypeOptions = response.data;
      });
    },
    /** 部门列表 */
    getDeptList() {
      listDept(this.queryParams2).then(response => {
          this.deptList = response.data;
          console.log(this.deptList)
      });
    },

    /** 查询【风险信息】列表 */
    getList() {
      this.loading = true;
      listManager(this.queryParams).then(response => {
        this.managerList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        riskPart: null,
        riskContent: null,
        riskLevel: null,
        riskType: null,
        riskControl: null,
        riskDept: null,
        riskPerson: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加【风险信息】";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getManager(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改【风险信息】";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateManager(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addManager(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除【风险信息】编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delManager(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有【风险信息】数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportManager(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
